PlayerAction.KingslayerSyringe = {
	Priority = 1,
	Function = function()
		local pm = managers.player
		local base_upgrade_data = pm:upgrade_value("player","kingslayer_syringe_base")
		local timer = TimerManager:game()
		local player = pm:local_player()
		if not alive(player) then 
			return
		end
		local dmg_ext = player:character_damage()

		local duration = base_upgrade_data.duration
		local end_time = timer:time() + duration
		
		local has_spread_bonus = pm:has_category_upgrade("player","kingslayer_syringe_spread_bonus")
		local has_rof_upgrade = pm:has_category_upgrade("player","kingslayer_syringe_rof_bonus")
		
		local function update_ability_radial()
			local time_left = end_time - timer:time()

			managers.hud:activate_teammate_ability_radial(HUDManager.PLAYER_PANEL, time_left, duration)
		end
		
		
		local on_fired_listener_key = "kingslayer_on_weapon_fired"
		if has_rof_upgrade then 
			local rof_bonus_upgrade_data = pm:upgrade_value("player","kingslayer_syringe_rof_bonus")
			local shots_per_stack = rof_bonus_upgrade_data.shots_per_stack
			local max_stacks = rof_bonus_upgrade_data.max_stacks
			pm:register_message(Message.OnWeaponFired,on_fired_listener_key,
				function(weapon_unit,result)
					local weapon_base = alive(weapon_unit) and weapon_unit:base()
					if weapon_base and weapon_base._setup and weapon_base._setup.user_unit and weapon_base._setup.user_unit == player then 
					
						local num_kingslayer_shots_fired = (pm:get_property("kingslayer_shots_fired",0) + 1) % shots_per_stack
						pm:set_property("kingslayer_shots_fired",num_kingslayer_shots_fired)
						--if player has fired shots_per_stack shots
						if num_kingslayer_shots_fired == 0 then 
							--add a stack
							local num_rof_bonus_stacks = math.min(pm:get_property("kingslayer_rof_bonus_stacks",0) + 1,max_stacks)
							pm:set_property("kingslayer_rof_bonus_stacks",num_rof_bonus_stacks)
						end
					end
				end
			)
		end
		
		if has_spread_bonus then 
			local spread_bonus = pm:upgrade_value("player","kingslayer_syringe_spread_bonus",0)
			pm:set_property("kingslayer_spread_bonus",spread_bonus)
		end
		
		update_ability_radial()
		while alive(player) and timer:time() < end_time do 
			coroutine.yield()
		end
		
		
		managers.hud:set_teammate_ability_radial(HUDManager.PLAYER_PANEL, {current=0,total=1})
		
		pm:set_property("kingslayer_rof_bonus_stacks",0)
		pm:set_property("kingslayer_spread_bonus",0)
		pm:unregister_message(Message.OnWeaponFired, on_fired_listener_key)
		
		
		--don't allow the next syringe coroutine to proc unless it's off cooldown
		while not pm:got_max_grenades() do 
			coroutine.yield()
		end
	end
}