
local paid = false
--if you want this perk deck to be instantly unlocked, change the above "true" to "false" (no quotation marks)



Hooks:PostHook(SkillTreeTweakData,"init","kingslayer_initskilltree",function(self,data)
	local costs = {
		[1] = 200,
		[2] = 300,
		[3] = 400,
		[4] = 600,
		[5] = 1000,
		[6] = 1600,
		[7] = 2400,
		[8] = 3200,
		[9] = 4000
	}
	local function cost(n)
		return paid and costs[n] or 0
	end

	local deck2 = {
		cost = cost(2),
		name_id = "menu_deckall_2",
		desc_id = "menu_deck_kingslayer_2_desc",
		upgrades = {
			"weapon_passive_headshot_damage_multiplier"
		},
		icon_xy = {
			1,
			0
		}
	}
	local deck4 = {
		cost = cost(4),
		name_id = "menu_deckall_4",
		desc_id = "menu_deck_kingslayer_4_desc",
		upgrades = {
			"passive_player_xp_multiplier",
			"player_passive_suspicion_bonus",
			"player_passive_armor_movement_penalty_multiplier"
		},
		icon_xy = {
			3,
			0
		}
	}
	local deck6 = {
		cost = cost(6),
		name_id = "menu_deckall_6",
		desc_id = "menu_deck_kingslayer_6_desc",
		upgrades = {
			"armor_kit",
			"player_pick_up_ammo_multiplier"
		},
		icon_xy = {
			5,
			0
		}
	}
	local deck8 = {
		cost = cost(8),
		name_id = "menu_deckall_8",
		desc_id = "menu_deck_kingslayer_8_desc",
		upgrades = {
			"weapon_passive_damage_multiplier",
			"passive_doctor_bag_interaction_speed_multiplier"
		},
		icon_xy = {
			7,
			0
		}
	}

	table.insert(self.specializations,
		{
			name_id = "menu_deck_kingslayer_title",
			desc_id = "menu_deck_kingslayer_desc",
			{
				upgrades = {
					"player_kingslayer_stacks_on_kill",
					"player_kingslayer_stacks_to_damage_mul"
				},
				cost = cost(1),
				icon_xy = {2, 7},
				name_id = "menu_deck_kingslayer_1",
				desc_id = "menu_deck_kingslayer_1_desc"
			},
			deck2,
			{
				upgrades = {
					"player_kingslayer_stacks_to_damage_resist"
				},
				cost = cost(3),
				icon_xy = {6, 0},
				name_id = "menu_deck_kingslayer_3",
				desc_id = "menu_deck_kingslayer_3_desc"
			},
			deck4,
			{
				upgrades = {
					"player_kingslayer_melee_speed_bonus",
--					"melee_stacking_hit_expire_t",
					"melee_stacking_hit_damage_multiplier_1",
					"player_kingslayer_melee_stacking_hit_expire_t"
				},
				cost = cost(5),
				icon_xy = {6, 4},
				name_id = "menu_deck_kingslayer_5",
				desc_id = "menu_deck_kingslayer_5_desc"
			},
			deck6,
			{
				upgrades = {
					"player_uncover_multiplier",
					"player_kingslayer_health_on_kill"
				},
				cost = cost(7),
				icon_xy = {1, 5},
				name_id = "menu_deck_kingslayer_7",
				desc_id = "menu_deck_kingslayer_7_desc"
			},
			deck8,
			{
				upgrades = {
					"kingslayer_syringe",
					"player_kingslayer_syringe_base",
					"player_kingslayer_syringe_temporary_spread_bonus",
					"player_kingslayer_syringe_temporary_stacking_rof_bonus"
				},
				cost = cost(9),
				texture_bundle_folder = "chico",
				icon_xy = {0, 1},
				name_id = "menu_deck_kingslayer_9",
				desc_id = "menu_deck_kingslayer_9_desc"
			}
		}
	)
	
	
	Hooks:Add("KineticTrackers_OnBuffDataLoaded","KingslayerPerkDeck_AddKineticTrackersData",function(kt_td)
	--compatibility with KineticTrackers, my (Offyerrocker's) standalone buff tracker mod
	--[[
		local perkdeck_num
		kt_td.buffs.asdds = {
			disabled = false,
			source = "perk",
			text_id = "menu_deck22_1",
			icon1data = {
				source = "perk",
				tree = 1,
				card = 1
			},
			
		}
		
		kt_td.buffs_lookup_table.properties.asdf = "asdf"
	--]]
	end)
	
end)